var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var date_exports = {};
__export(date_exports, {
  default: () => date_default
});
module.exports = __toCommonJS(date_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_moment_timezone = __toESM(require("moment-timezone"));
var import_datemath = __toESM(require("@elastic/datemath"));
let dateMin = -864e13;
let dateMax = 864e13;
let getStartOfQuarter = (quarterOffset, timezone) => {
  let quarter = (0, import_moment_timezone.default)().tz(timezone).quarter() + quarterOffset;
  return (0, import_moment_timezone.default)().tz(timezone).quarter(quarter).startOf("quarter");
};
let getEndOfQuarter = (date) => (0, import_moment_timezone.default)(date).add(1, "Q").subtract(1, "ms");
let quarterToOffset = {
  thisCalendarQuarter: 0,
  lastCalendarQuarter: -1,
  nextCalendarQuarter: 1
};
let rangeToDatemath = {
  last1Hour: { from: "now-1h", to: "now" },
  last1Day: { from: "now-1d", to: "now" },
  last3Days: { from: "now-3d", to: "now" },
  last7Days: { from: "now-7d", to: "now" },
  last30Days: { from: "now-30d", to: "now" },
  last90Days: { from: "now-90d", to: "now" },
  last180Days: { from: "now-180d", to: "now" },
  last12Months: { from: "now/d-12M", to: "now" },
  last15Months: { from: "now/d-15M", to: "now" },
  last18Months: { from: "now/d-18M", to: "now" },
  last24Months: { from: "now/d-24M", to: "now" },
  last36Months: { from: "now/d-36M", to: "now" },
  last48Months: { from: "now/d-48M", to: "now" },
  last60Months: { from: "now/d-60M", to: "now" },
  lastCalendarMonth: { from: "now-1M/M", to: "now/M-1ms" },
  lastCalendarYear: { from: "now-1y/y", to: "now/y-1ms" },
  thisCalendarMonth: { from: "now/M", to: "now+1M/M-1ms" },
  thisCalendarYear: { from: "now/y", to: "now+1y/y-1ms" },
  nextCalendarMonth: { from: "now+1M/M", to: "now+2M/M-1ms" },
  nextCalendarYear: { from: "now+1y/y", to: "now+2y/y-1ms" },
  next30Days: { from: "now/d", to: "now/d+30d-1ms" },
  next60Days: { from: "now/d", to: "now/d+60d-1ms" },
  next90Days: { from: "now/d", to: "now/d+90d-1ms" },
  next6Months: { from: "now/d", to: "now/d+6M-1ms" },
  next12Months: { from: "now/d", to: "now/d+12M-1ms" },
  next18Months: { from: "now/d", to: "now/d+18M-1ms" },
  next24Months: { from: "now/d", to: "now/d+24M-1ms" },
  next36Months: { from: "now/d", to: "now/d+36M-1ms" },
  allPastDates: { from: "", to: "now/d-1ms" },
  allFutureDates: { from: "now/d", to: "" }
};
let parseAndShift = (exp, timezone) => {
  let computed = import_datemath.default.parse(exp);
  return /\//.test(exp) ? (0, import_moment_timezone.default)(computed).tz(timezone, true) : computed;
};
let rollingRangeToDates = (range, timezone) => {
  if (import_fp.default.has(range, quarterToOffset)) {
    let from = getStartOfQuarter(quarterToOffset[range], timezone);
    let to = getEndOfQuarter(from);
    return { from, to };
  } else {
    let expressions = rangeToDatemath[range];
    let from = parseAndShift(expressions.from, timezone);
    let to = parseAndShift(expressions.to, timezone);
    return { from, to };
  }
};
let dateTypeToFormatFn = {
  date: (x) => x && import_moment_timezone.default.utc(x).toDate(),
  unix: (x) => x && import_moment_timezone.default.utc(x).unix(),
  timestamp: (x) => x && new Date(x).getTime()
};
let hasValue = ({ from, to, range }) => range && range !== "allDates" && (range === "exact" && (from || to) || range !== "exact");
var date_default = {
  hasValue,
  // NOTE: timezone is only used for rolling dates
  filter({
    field,
    range,
    dateType = "timestamp",
    timezone = "UTC",
    ...context
  }) {
    let { from, to } = range === "exact" ? context : rollingRangeToDates(range, timezone);
    let format = dateTypeToFormatFn[dateType];
    if (!from) {
      from = dateMin;
    }
    if (!to) {
      to = dateMax;
    }
    return import_fp.default.flow(import_fp.default.get(field), format, import_fp.default.inRange(format(from), format(to)));
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
