var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var exampleTypes_exports = {};
__export(exampleTypes_exports, {
  default: () => exampleTypes_default
});
module.exports = __toCommonJS(exampleTypes_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_date = __toESM(require("./date.js"));
var import_results = __toESM(require("./results.js"));
var exampleTypes_default = () => ({
  default: {
    validContext: () => true,
    hasValue: () => true
  },
  date: import_date.default,
  results: import_results.default,
  number: {
    hasValue: (node) => import_futil.default.isNotNil(node.min) || import_futil.default.isNotNil(node.max),
    filter: ({ field, min = -Infinity, max = Infinity }) => import_fp.default.conforms({
      [field]: import_fp.default.inRange(min, max)
    })
  },
  exists: {
    hasValue: ({ value }) => import_fp.default.isBoolean(value),
    filter: ({ field, value }) => (
      // No _.conforms here since it does not get invoked on props which do not exist
      import_fp.default.flow(import_fp.default.get(field), value ? import_futil.default.isNotNil : import_fp.default.isNil)
    )
  },
  bool: {
    hasValue: ({ value }) => import_fp.default.isBoolean(value),
    filter: ({ field, value }) => import_fp.default.conforms({
      [field]: import_fp.default.isEqual(value)
    })
  },
  facet: {
    hasValue: (node) => import_fp.default.size(node.values),
    filter: ({ field, values, mode = "include" }) => import_fp.default.flow(
      import_fp.default.get(field),
      import_fp.default.castArray,
      mode === "include" ? import_fp.default.intersectionWith(import_fp.default.isEqual, values) : import_fp.default.differenceWith(import_fp.default.isEqual, import_fp.default, values),
      import_fp.default.negate(import_fp.default.isEmpty)
    ),
    result({ field, size = 10, optionsFilter }, search) {
      let options = search(
        import_fp.default.flow(
          import_fp.default.flatMap(field),
          import_fp.default.reject(import_fp.default.isUndefined),
          import_fp.default.map(JSON.stringify),
          optionsFilter ? import_fp.default.filter(import_futil.default.matchAnyWord(optionsFilter)) : import_fp.default.identity,
          import_fp.default.countBy(import_fp.default.identity),
          import_fp.default.toPairs,
          import_fp.default.map(([name, count]) => ({ name: JSON.parse(name), count })),
          import_fp.default.orderBy("count", "desc")
        )
      );
      return {
        cardinality: import_fp.default.size(options),
        options: size ? import_fp.default.take(size, options) : options
      };
    }
  },
  text: {
    hasValue: (node) => node.value || import_fp.default.size(node.values),
    filter({ join = "all", values, value, operator = "containsWord", field }) {
      let regexMap = (operator2, val) => ({
        containsWord: val,
        startsWith: `^${val}`,
        wordStartsWith: `\\b${val}`,
        endsWith: `${val}$`,
        wordEndsWith: `${val}\\b`,
        is: `^${val}$`,
        containsExact: `\\b${val}\\b`
      })[operator2];
      let conditions = import_fp.default.map(
        (nodeValue) => (recordValue) => RegExp(regexMap(operator, nodeValue), "i").test(recordValue),
        values || [value]
      );
      let combinator = {
        all: import_fp.default.overEvery,
        any: import_fp.default.overSome,
        none: import_futil.default.overNone
      }[join];
      return import_fp.default.conforms({
        [field]: combinator(conditions)
      });
    }
  },
  statistical: {
    result: ({ field }, search) => ({
      count: search(import_fp.default.size),
      avg: search(import_fp.default.meanBy(field)),
      max: search(import_fp.default.maxBy(field)),
      min: search(import_fp.default.minBy(field)),
      sum: search(import_fp.default.sumBy(field))
    })
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
