var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  Tree: () => Tree,
  attachFilters: () => attachFilters,
  getProvider: () => getProvider,
  getRelevantFilters: () => getRelevantFilters,
  runTypeFunction: () => runTypeFunction
});
module.exports = __toCommonJS(utils_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
let getChildren = (x) => import_futil.default.cascade(["children", "items", "data.items"], x);
let Tree = import_futil.default.tree(getChildren);
let getRelevantFilters = import_fp.default.curry((groupCombinator, Path, group) => {
  if (!import_fp.default.includes(group.key, Path))
    Path = [];
  let path = Path.slice(1);
  let currentKey = path[0];
  let relevantChildren = getChildren(group);
  if (!relevantChildren)
    return group._meta.filter;
  if (group.join === "or" && currentKey)
    relevantChildren = import_fp.default.filter({ key: currentKey }, relevantChildren);
  relevantChildren = import_fp.default.reject(
    (node) => node.key === currentKey && !getChildren(node),
    relevantChildren
  );
  let relevantFilters = import_fp.default.compact(
    import_fp.default.map(getRelevantFilters(groupCombinator, path), relevantChildren)
  );
  if (!relevantFilters.length)
    return;
  if (relevantFilters.length === 1 && group.join !== "not")
    return relevantFilters[0];
  return groupCombinator(group, import_fp.default.compact(relevantFilters));
});
let getProvider = import_fp.default.curry(
  (providers, schemas, node) => providers[node.provider || import_fp.default.get("provider", schemas[node.schema]) || import_futil.default.firstCommonKey(providers, schemas[node.schema])] || import_futil.default.throws(
    new Error(
      `No Provider found ${node.schema} and was not overridden for ${node.key}`
    )
  )
);
let runTypeFunction = (config) => async (name, node, search) => {
  let schema = config.getSchema(node.schema);
  let fn = import_futil.default.cascade(
    [`${node.type}.${name}`, `default.${name}`],
    config.getProvider(node).types,
    import_fp.default.noop
  );
  try {
    return await (search ? fn(node, search, schema, config) : fn(node, schema, config));
  } catch (error) {
    throw {
      message: `Failed running search for ${node.type} (${node.key}) at ${name}: ${import_fp.default.getOr(error, "message", error)}`,
      error,
      node
    };
  }
};
let extendAllOn = import_fp.default.extendAll.convert({ immutable: false });
let initNode = (node, i, [{ schema, _meta: { path = [] } = {} } = {}]) => {
  import_futil.default.defaultsOn(
    { schema, _meta: { requests: [], path: path.concat([node.key]) } },
    node
  );
  extendAllOn([node, node.config, node.data]);
};
let attachFilters = (runTypeFunction2) => async (group) => Tree.walkAsync(async (node, ...args) => {
  initNode(node, ...args);
  node._meta.hasValue = await runTypeFunction2("hasValue", node);
  if (node._meta.hasValue && !node.contextOnly) {
    node._meta.filter = await runTypeFunction2("filter", node);
  }
})(group);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Tree,
  attachFilters,
  getProvider,
  getRelevantFilters,
  runTypeFunction
});
